import pyglet
import Box2D.Box2D as b2
import grfx
import physics
import math

gl = pyglet.gl

class Blob(object):
    def __init__(self, x, y, r, b2world=None):
        self.x = x
        self.y = y
        self.r = r
        self.theta = 0
        self.tex = pyglet.resource.texture('data/blob.png')
        self.phys_obj = None

        print "BLOB", x, y
        if b2world:
            d = physics.get_circle_definition(b2world, self.r*0.3, 0.25, 0.05)
            self.phys_obj = physics.Circle(d, b2.b2Vec2(x, y))
            print self.phys_obj.body


    def update(self, dt):
        if self.phys_obj:
            self.x = self.phys_obj.body.position.x
            self.y = self.phys_obj.body.position.y
            self.theta = self.phys_obj.body.angle * (180/math.pi)

    def draw(blob):
        #blob.phys_obj.draw()
        gl.glPushMatrix()
        gl.glTranslatef(blob.x, blob.y, 0)
        gl.glRotatef(blob.theta, 0, 0, 1)
        grfx.draw_image(-blob.r, 
                        -blob.r, 
                        blob.r*2, 
                        blob.r*2, 
                        blob.tex)
        gl.glPopMatrix()

    def delayed_draw(self):
        return lambda: self.draw()